! Dean Townsley 2010

subroutine Simulation_init()
  
  use Simulation_data
  use RuntimeParameters_interface, ONLY : RuntimeParameters_get
  use Eos_interface, ONLY: Eos
  implicit none
#include "Flash.h"
#include "constants.h"
#include "Eos.h"

  integer :: he4i, c12i, o16i

!===========================================================================

  he4i = HE4_SPEC-SPECIES_BEGIN+1
  c12i = C12_SPEC-SPECIES_BEGIN+1
  o16i = O16_SPEC-SPECIES_BEGIN+1

  ! initialize these
  sim_fuel%abundData(:) = 0.0
  sim_inert%abundData(:) = 0.0

  call RuntimeParameters_get("temp_he", sim_fuel%eosData(EOS_TEMP))
  call RuntimeParameters_get("dens_he", sim_fuel%eosData(EOS_DENS))
  call RuntimeParameters_get("x_c12", sim_fuel%abundData(c12i))
  call RuntimeParameters_get("x_o16", sim_fuel%abundData(o16i))
  sim_fuel%abundData(he4i) = 1.0-sim_fuel%abundData(c12i)-sim_fuel%abundData(o16i)

  call RuntimeParameters_get("dens_inert", sim_inert%eosData(EOS_DENS))

  ! now finish setting up fuel and inert state information
  call Eos(MODE_DENS_TEMP, 1, sim_fuel%eosData, sim_fuel%abundData)

  sim_inert%abundData(NI56_SPEC-SPECIES_BEGIN+1) = 1.0
  sim_inert%eosData(EOS_PRES) = sim_fuel%eosData(EOS_PRES)
  ! guess temperature
  sim_inert%eosData(EOS_TEMP) = sim_fuel%eosData(EOS_TEMP)

  call Eos(MODE_DENS_PRES, 1, sim_inert%eosData, sim_inert%abundData)


  call RuntimeParameters_get("he_half_width", sim_he_half_width)

  call RuntimeParameters_get("ign_x", sim_ign_x)
  call RuntimeParameters_get("ign_y", sim_ign_y)
  call RuntimeParameters_get("ign_r", sim_ign_r)
  call RuntimeParameters_get("ign_temp_center", sim_ign_temp_center)
  call RuntimeParameters_get("ign_temp_edge", sim_ign_temp_edge)

  call RuntimeParameters_get("shk_pos_band_bot", sim_shk_pos_band_bot)
  call RuntimeParameters_get("shk_pos_band_top", sim_shk_pos_band_top)
  call RuntimeParameters_get("shk_pos_temp_thresh", sim_shk_pos_temp_thresh)

  call RuntimeParameters_get('refFluffDensThresh', sim_refFluffDensThresh)
  call RuntimeParameters_get('refFluffMargin', sim_refFluffMargin)
  call RuntimeParameters_get('refFluffLevel', sim_refFluffLevel)

  call RuntimeParameters_get('refNogenEnucThresh', sim_refNogenEnucThresh)
  call RuntimeParameters_get('refNogenMargin', sim_refNogenMargin)
  call RuntimeParameters_get('refNogenLevel', sim_refNogenLevel)

  sim_refFuelHe4Abund = sim_fuel%abundData(he4i)
  sim_refInertNi56Abund = 1.0


end subroutine Simulation_init

